/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_CONFIG_FILE_H_
#define __GDAM_CONFIG_FILE_H_

#include <glib.h>
#include <stdio.h>
/*
 * Syntax:
 *      DeviceType  "module_method"   "parameter"
 *      Device "device_name" "type"
 *      User "username"
 *      Group "groupname"
 *      PidFile "pid-filename"
 *      LogFile "log-filename"
 *      Daemon "yes/no"
 *      Debug "yes/no"
 */
gboolean       gdam_config_file_parse(const char* filename);


/* Globals for configuring daemon behavior. */
extern const char*           gdam_username;
extern const char*           gdam_groupname;
extern const char*           gdam_pid_file;
extern FILE*                 gdam_log_fp;
extern gboolean              gdam_daemonize;

/* When we do `bind', bind only to localhost. */
extern gboolean              gdam_bind_localhost;

#endif
