/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_ONE_IIR_H_
#define __GDAM_SYNTH_ONE_IIR_H_

#include "gdamsynthfilter.h"

typedef struct _GdamSynthOneIir GdamSynthOneIir;
typedef struct _GdamSynthOneIirClass GdamSynthOneIirClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_one_iir_get_type();
#define GDAM_TYPE_SYNTH_ONE_IIR			(gdam_synth_one_iir_get_type ())
#define GDAM_SYNTH_ONE_IIR(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_ONE_IIR, GdamSynthOneIir))
#define GDAM_SYNTH_ONE_IIR_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_ONE_IIR, GdamSynthOneIirClass))
#define GDAM_IS_SYNTH_ONE_IIR(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_ONE_IIR))
#define GDAM_IS_SYNTH_ONE_IIR_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_ONE_IIR))

struct _GdamSynthOneIirClass {
	GdamSynthFilterClass		synth_one_iir_class;
};
struct _GdamSynthOneIir {
	GdamSynthFilter			synth_one_iir;
	/* output[n] = coeff[0] * input[n] + coeff[1] * output[n-1] */
	gdouble				coeff[2];

	gdouble				last_sample;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
