/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
*/
#ifndef __GDAM_SYNTH_TWO_IIR_H_
#define __GDAM_SYNTH_TWO_IIR_H_

#include "gdamsynthfilter.h"

typedef struct _GdamSynthTwoIir GdamSynthTwoIir;
typedef struct _GdamSynthTwoIirClass GdamSynthTwoIirClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_synth_two_iir_get_type();
#define GDAM_TYPE_SYNTH_TWO_IIR			(gdam_synth_two_iir_get_type ())
#define GDAM_SYNTH_TWO_IIR(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_SYNTH_TWO_IIR, GdamSynthTwoIir))
#define GDAM_SYNTH_TWO_IIR_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_SYNTH_TWO_IIR, GdamSynthTwoIirClass))
#define GDAM_IS_SYNTH_TWO_IIR(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_SYNTH_TWO_IIR))
#define GDAM_IS_SYNTH_TWO_IIR_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_SYNTH_TWO_IIR))

struct _GdamSynthTwoIirClass {
	GdamSynthFilterClass		synth_two_iir_class;
};
struct _GdamSynthTwoIir {
	GdamSynthFilter			synth_two_iir;
	/* output[n] = coeff[0] * input[n]
	             + coeff[1] * output[n-1]
		     + coeff[2] * output[n-2]  */
	gdouble				coeff[3];
	gdouble				last_samples[2];
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
